## fcitx5 0~20181128+ds1

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(addon)

set(FCITX_UTILS_TEST
    testflags
    teststringutils
    testkey
    testutf8
    testcolor
    testi18nstring
    testevent
    testlist
    testfs
    testlibrary
    teststandardpath
    testunixfd
    testmetastring
    testhandlertable
    testsignals
    testinputbuffer
    testlog)

set(FCITX_UTILS_DBUS_TEST
    testdbusmessage
    testdbus
    testservicewatcher)

set(testdbus_LIBS Pthread::Pthread)

add_executable(DBusWrapper IMPORTED)
set_target_properties(DBusWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/dbus_wrapper.sh")

foreach(TESTCASE ${FCITX_UTILS_DBUS_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND DBusWrapper "${CMAKE_CURRENT_BINARY_DIR}/${TESTCASE}" ${${TESTCASE}_ARGS})
endforeach()

foreach(TESTCASE ${FCITX_UTILS_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()
set_target_properties(testlibrary PROPERTIES LINK_FLAGS "-rdynamic")

set(FCITX_CONFIG_TEST
    testconfig
    testconfigdbus)

foreach(TESTCASE ${FCITX_CONFIG_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Config)
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

set(FCITX_CORE_TEST
    testinputcontext
    testsurroundingtext
    testaddon
    testmenu
    testuserinterfacemanager
    testelement
    testcandidatelist
    testicontheme)
foreach(TESTCASE ${FCITX_CORE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Core)
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()

add_dependencies(testaddon dummyaddon)

add_executable(testxkbrules testxkbrules.cpp ../src/im/keyboard/xkbrules.cpp ../src/im/keyboard/xmlparser.cpp)
target_compile_definitions(testxkbrules PRIVATE "-D_TEST_XKBRULES")
target_include_directories(testxkbrules PRIVATE ../src)
target_link_libraries(testxkbrules Fcitx5::Utils Expat::Expat)
add_test(NAME testxkbrules COMMAND testxkbrules)

=== src/lib/fcitx-utils/CMakeLists.txt ===
if (NOT TARGET Systemd::Systemd)
  set(FCITX_UTILS_SOURCES
      dbus/libdbus/bus.cpp
      dbus/libdbus/message.cpp
      dbus/libdbus/objectvtable.cpp
      dbus/libdbus/servicenamecache.cpp)
else()
  set(FCITX_UTILS_SOURCES
      dbus/sdbus/bus.cpp
      dbus/sdbus/message.cpp
      dbus/sdbus/objectvtablewrapper.c
      dbus/sdbus/objectvtable.cpp)
endif()

if (NOT TARGET Systemd::Systemd)
  set(FCITX_UTILS_SOURCES
    ${FCITX_UTILS_SOURCES}
    event_libevent.cpp)
else()
  set(FCITX_UTILS_SOURCES
    ${FCITX_UTILS_SOURCES}
    event_sdevent.cpp)
endif()

set(FCITX_UTILS_SOURCES
    ${FCITX_UTILS_SOURCES}
    dbus/servicewatcher.cpp
    dbus/matchrule.cpp
    dbus/variant.cpp
    stringutils.cpp
    key.cpp
    cutf8.cpp
    color.cpp
    i18nstring.cpp
    event_common.cpp
    library.cpp
    fs.cpp
    standardpath.cpp
    unixfd.cpp
    utf8.cpp
    connectableobject.cpp
    element.cpp
    i18n.cpp
    inputbuffer.cpp
    log.cpp
    misc.cpp
    )

set(FCITX_UTILS_HEADERS
    macros.h
    stringutils.h
    stringutils_details.h
    key.h
    color.h
    i18nstring.h
    event.h
    library.h
    cutf8.h
    fs.h
    standardpath.h
    tuplehelpers.h
    metastring.h
    unixfd.h
    trackableobject.h
    connectableobject.h
    flags.h
    keysym.h
    keysymgen.h
    signals.h
    signals_details.h
    handlertable.h
    handlertable_details.h
    intrusivelist.h
    misc.h
    utf8.h
    cutf8.h
    element.h
    rect.h
    charutils.h
    i18n.h
    capabilityflags.h
    textformatflags.h
    inputbuffer.h
    log.h
    ${CMAKE_CURRENT_BINARY_DIR}/fcitxutils_export.h
    )

set(FCITX_UTILS_DBUS_HEADERS
    dbus/message.h
    dbus/objectvtable.h
    dbus/bus.h
    dbus/message_details.h
    dbus/servicewatcher.h
    dbus/matchrule.h
    )

add_library(Fcitx5Utils SHARED ${FCITX_UTILS_SOURCES})
set_target_properties(Fcitx5Utils
  PROPERTIES VERSION 1.0
  SOVERSION 1
  EXPORT_NAME Utils
  )
target_include_directories(Fcitx5Utils PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/Fcitx5/Utils>)
target_link_libraries(Fcitx5Utils PRIVATE DL::DL LibIntl::LibIntl Pthread::Pthread)

if (NOT TARGET Systemd::Systemd)
target_link_libraries(Fcitx5Utils PRIVATE PkgConfig::DBus PkgConfig::LibEvent)
else()
target_link_libraries(Fcitx5Utils PRIVATE Systemd::Systemd)
endif()

configure_file(Fcitx5Utils.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Utils.pc @ONLY)

install(TARGETS Fcitx5Utils EXPORT Fcitx5UtilsTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Utils.pc
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/Utils/fcitx-utils")
install(FILES ${FCITX_UTILS_DBUS_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/Utils/fcitx-utils/dbus")

add_library(Fcitx5::Utils ALIAS Fcitx5Utils)

ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5UtilsConfigVersion.cmake"
                  SOVERSION 1)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Fcitx5UtilsConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5UtilsConfig.cmake"
                              INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Utils
)

generate_export_header(Fcitx5Utils BASE_NAME FcitxUtils)

install(EXPORT Fcitx5UtilsTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Utils FILE Fcitx5UtilsTargets.cmake NAMESPACE Fcitx5::)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5UtilsConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5UtilsConfigVersion.cmake"
               Fcitx5Macros.cmake
               Fcitx5Download.cmake.in
               Fcitx5ModuleTemplate.cmake.in
               "${CMAKE_SOURCE_DIR}/cmake/Fcitx5CompilerSettings.cmake"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Utils
        COMPONENT Devel )

=== src/ui/classic/CMakeLists.txt ===
add_subdirectory(themes)

add_library(classicui MODULE classicui.cpp xcbui.cpp xcbwindow.cpp window.cpp theme.cpp waylandui.cpp waylandwindow.cpp waylandeglwindow.cpp waylandshmwindow.cpp buffer.cpp waylandinputwindow.cpp xcbtraywindow.cpp inputwindow.cpp xcbinputwindow.cpp xcbmenu.cpp)

if (CAIRO_EGL_FOUND)
set(CAIRO_EGL_LIBRARY PkgConfig::CairoEGL Wayland::Egl EGL::EGL)
else()
set(CAIRO_EGL_LIBRARY)
endif()

target_link_libraries(classicui
    Fcitx5::Core
    PkgConfig::Cairo PkgConfig::CairoXCB PkgConfig::Pango
    PkgConfig::GdkPixbuf PkgConfig::GioUnix
    Fcitx5::Module::XCB Fcitx5::Module::Wayland Fcitx5::Module::NotificationItem
    XCB::AUX XCB::ICCCM XCB::XINERAMA Wayland::Client XCB::RANDR XCB::EWMH
    ${CAIRO_EGL_LIBRARY}
    Fcitx5::Wayland::Core Fcitx5::Wayland::InputMethod
    ${FMT_TARGET})
set_target_properties(classicui PROPERTIES PREFIX "")
install(TARGETS classicui DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(classicui.conf.in classicui.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/classicui.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")

=== debian/changelog ===
fcitx5 (0~20181128+ds1-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.3.0.
  * debian/changelog: Fix ITP bug number.

 -- Boyuan Yang <byang@debian.org>  Mon, 14 Jan 2019 10:38:49 -0500

fcitx5 (0~20181128+ds1-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #915567)

 -- Boyuan Yang <byang@debian.org>  Thu, 06 Dec 2018 14:02:04 -0500

=== debian/control ===
Source: fcitx5
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.6.0),
 dbus,
 debhelper-compat (= 12),
 extra-cmake-modules,
 gettext,
 iso-codes,
 libcairo2-dev,
 libdbus-1-dev,
 libegl1-mesa-dev,
 libenchant-dev,
 libevent-dev,
 libexpat1-dev,
 libfmt-dev,
 libgdk-pixbuf2.0-dev,
 libjson-c-dev,
 libpango1.0-dev,
 libsystemd-dev,
 libwayland-bin,
 libwayland-dev,
 libwayland-egl-backend-dev,
 libxcb-ewmh-dev,
 libxcb-icccm4-dev,
 libxcb-imdkit-dev,
 libxcb-randr0-dev,
 libxcb-shape0-dev,
 libxcb-xfixes0-dev,
 libxcb-xinerama0-dev,
 libxcb-xkb-dev,
 libxcb1-dev,
 libxkbcommon-x11-dev,
 libxkbfile-dev,
 pkg-config,
 uuid-dev,
 wayland-protocols,
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/fcitx/fcitx5
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5

Package: fcitx5
Architecture: linux-any
Depends:
 fcitx5-data (= ${source:Version}),
 fcitx5-modules (= ${binary:Version}),
 libfcitx5config5 (= ${binary:Version}),
 libfcitx5core5 (= ${binary:Version}),
 libfcitx5utils1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Next generation of Fcitx Input Method Framework
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides core fcitx5 framework files.

Package: fcitx5-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (common data files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides architecture-independent data files.

Package: fcitx5-module-dbus
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (dbus module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides dbus module for fcitx5.

Package: fcitx5-module-ibus
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (ibus module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides ibus-compatibility module for fcitx5.

Package: fcitx5-module-kimpanel
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (kimpanel module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides kimpanel module for fcitx5.

Package: fcitx5-module-wayland
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (wayland modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides wayland-related modules for fcitx5.

Package: fcitx5-module-xorg
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (xorg modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides xorg-related modules for fcitx5.

Package: fcitx5-module-quickphrase
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fcitx5-module-quickphrase-editor,
Description: Fcitx Input Method Framework v5 (quickphrase module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides quickphrase module for fcitx5.

Package: fcitx5-modules
Architecture: linux-any
Depends:
 fcitx5-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fcitx5-module-dbus,
 fcitx5-module-ibus,
 fcitx5-module-kimpanel,
 fcitx5-module-wayland,
 fcitx5-module-xorg,
 fcitx5-module-quickphrase,
Description: Fcitx Input Method Framework v5 (core modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides core modules for fcitx5 and depends on all
 input modules.

Package: fcitx5-modules-dev
Architecture: linux-any
Section: libdevel
Depends:
 fcitx5-module-dbus (= ${binary:Version}),
 fcitx5-module-ibus (= ${binary:Version}),
 fcitx5-module-kimpanel (= ${binary:Version}),
 fcitx5-module-wayland (= ${binary:Version}),
 fcitx5-module-xorg (= ${binary:Version}),
 fcitx5-module-quickphrase (= ${binary:Version}),
 fcitx5-modules (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (input modules dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 input modules.

Package: libfcitx5config-dev
Architecture: linux-any
Section: libdevel
Depends:
 libfcitx5config5 (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (config library dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 config libraries.

Package: libfcitx5config5
Architecture: linux-any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (config library)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides fcitx5 config libraries.

Package: libfcitx5core-dev
Architecture: linux-any
Section: libdevel
Depends:
 libfcitx5core5 (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (core library dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 core libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# DBus-related test known to be failing, ignore
	# it for now
	-dh_auto_test
endif

## fcitx5 0.0~git20200128.9e3bc8d%2Bds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.0)
set(FCITX_VERSION 4.99.0)
project(fcitx VERSION ${FCITX_VERSION})

find_package(ECM REQUIRED 1.0.0)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

#######################################################################
# CMake macros
#######################################################################
include(FeatureSummary)
include(GNUInstallDirs)
include(ECMSetupVersion)
include(GenerateExportHeader)
include(WriteBasicConfigVersionFile)
include(ECMUninstallTarget)
include(src/lib/fcitx-utils/Fcitx5Macros.cmake)

#######################################################################
# Options
#######################################################################
option(ENABLE_TEST "Build Test" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
set(DEFAULT_XKB_RULES "evdev" CACHE STRING "Xkb rules name")
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" Off)
option(ENABLE_DOC "Build doxygen" Off)
option(USE_SYSTEMD "Use systemd for event loop and dbus, will fallback to libevent/libdbus if not found." On)

#######################################################################
# Find packages
#######################################################################

find_package(PkgConfig REQUIRED)

if (USE_SYSTEMD)
find_package(Systemd)
endif ()

if (NOT TARGET Systemd::Systemd)
pkg_check_modules(DBus REQUIRED IMPORTED_TARGET "dbus-1")
pkg_get_variable(DBUS_SYSTEM_BUS_DEFAULT_ADDRESS "dbus-1" "system_bus_default_address")
pkg_check_modules(LibEvent REQUIRED IMPORTED_TARGET "libevent")
endif()

find_package(DL REQUIRED)
find_package(LibIntl REQUIRED)
find_package(LibUUID REQUIRED)
find_package(Pthread REQUIRED)
find_package(Execinfo)
find_package(Gettext REQUIRED)
find_package(fmt REQUIRED)

if (TARGET fmt::fmt-header-only)
  set(FMT_TARGET fmt::fmt-header-only)
else()
  set(FMT_TARGET fmt::fmt)
endif ()

find_package(XCB COMPONENTS XCB AUX XKB XFIXES ICCCM XINERAMA RANDR EWMH KEYSYMS)
find_package(XKBCommon COMPONENTS XKBCommon X11)
find_package(XCBImdkit)
find_package(IsoCodes REQUIRED)
find_package(Expat REQUIRED)
find_package(XKeyboardConfig)
pkg_check_modules(JsonC REQUIRED IMPORTED_TARGET "json-c")
pkg_check_modules(XkbFile REQUIRED IMPORTED_TARGET "xkbfile")
pkg_check_modules(Cairo IMPORTED_TARGET cairo)
pkg_check_modules(CairoXCB IMPORTED_TARGET cairo-xcb)
pkg_check_modules(CairoEGL IMPORTED_TARGET cairo-egl)
pkg_check_modules(Pango IMPORTED_TARGET pango pangocairo)
pkg_check_modules(GdkPixbuf IMPORTED_TARGET gdk-pixbuf-2.0)
pkg_check_modules(GioUnix IMPORTED_TARGET gio-unix-2.0)
find_package(Wayland COMPONENTS Client Egl)
find_package(WaylandScanner)
find_package(WaylandProtocols)
find_package(EGL)

if(ENABLE_ENCHANT)
  pkg_check_modules(Enchant IMPORTED_TARGET "enchant-2")
  if(NOT TARGET PkgConfig::Enchant)
    pkg_check_modules(Enchant IMPORTED_TARGET "enchant" REQUIRED)
  endif()
endif()

if(ENABLE_PRESAGE)
  find_package(Presage REQUIRED)
endif()

if (TARGET PkgConfig::CairoEGL AND TARGET EGL::EGL AND TARGET Wayland::Egl)
  set(CAIRO_EGL_FOUND TRUE)
else()
  set(CAIRO_EGL_FOUND FALSE)
endif()

set(DEFAULT_XKB_RULES_FILES "${XKEYBOARDCONFIG_XKBBASE}/rules/${DEFAULT_XKB_RULES}.xml")
if (NOT EXISTS "${DEFAULT_XKB_RULES_FILES}")
message(FATAL_ERROR "Could not find default xkb rules file: ${DEFAULT_XKB_RULES_FILES}")
endif ()

# directory needed by bsd
if(NOT CMAKE_INSTALL_LIBDATADIR)
  set(CMAKE_INSTALL_LIBDATADIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "libdata root (LIBDIR)")
endif()

get_filename_component(CMAKE_INSTALL_FULL_LIBDATADIR "${CMAKE_INSTALL_LIBDATADIR}" ABSOLUTE)
mark_as_advanced(CMAKE_INSTALL_LIBDATADIR)
mark_as_advanced(CMAKE_INSTALL_FULL_LIBDATADIR)

include(Fcitx5CompilerSettings)

set(FCITX_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(FCITX_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(FCITX_INSTALL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})
set(FCITX_INSTALL_LIBDATADIR ${CMAKE_INSTALL_FULL_LIBDATADIR})
set(FCITX_INSTALL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR})
set(FCITX_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/fcitx5")
set(FCITX_INSTALL_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})
set(FCITX_INSTALL_LOCALEDIR ${CMAKE_INSTALL_FULL_LOCALEDIR})
set(FCITX_INSTALL_ADDONDIR "${CMAKE_INSTALL_FULL_LIBDIR}/fcitx5")
set(FCITX_INSTALL_CMAKECONFIG_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")
set(FCITX_INSTALL_MODULE_HEADER_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/Fcitx5/Module/fcitx-module")
# TODO mac/win
set(FCITX_LIBRARY_SUFFIX ".so")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(po)

#######################################################################
# Test features
#######################################################################
if (ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif ()

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/frontend/xim/CMakeLists.txt ===
add_library(xim MODULE xim.cpp)
target_link_libraries(xim Fcitx5::Core XCBImdkit::XCBImdkit XCB::XCB XCB::AUX XKBCommon::XKBCommon Fcitx5::Module::XCB)
set_target_properties(xim PROPERTIES PREFIX "")
install(TARGETS xim DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(xim.conf.in xim.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/xim.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")

=== src/modules/dbus/CMakeLists.txt ===
add_library(dbus MODULE dbusmodule.cpp)
target_link_libraries(dbus Fcitx5::Core Fcitx5::Module::Keyboard Fcitx5::Module::XCB XCB::XCB)
set_target_properties(dbus PROPERTIES PREFIX "")
install(TARGETS dbus DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(dbus.conf.in dbus.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dbus.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")
fcitx5_export_module(DBus TARGET dbus BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS dbus_public.h INSTALL)

=== src/modules/wayland/CMakeLists.txt ===
add_library(wayland MODULE waylandmodule.cpp)
target_link_libraries(wayland Fcitx5::Core Wayland::Client Fcitx5::Wayland::Core)
set_target_properties(wayland PROPERTIES PREFIX "")
install(TARGETS wayland DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(wayland.conf.in wayland.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wayland.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")
fcitx5_export_module(Wayland TARGET wayland BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS wayland_public.h INSTALL)

## fcitx5 0.0~git20200128.9e3bc8d+ds1

=== data/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fcitx5-configtool.desktop.in.in
               ${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop.in @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fcitx5.desktop.in.in
               ${CMAKE_CURRENT_BINARY_DIR}/fcitx5.desktop.in @ONLY)

fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop.in
                              fcitx5-configtool.desktop)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/fcitx5.desktop.in
                              fcitx5.desktop)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx5.desktop"
              "${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop"
        DESTINATION "${FCITX_INSTALL_DATADIR}/applications")

install(FILES fcitx5-configtool.sh RENAME fcitx5-configtool DESTINATION "${FCITX_INSTALL_BINDIR}" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,8 @@
     testhandlertable
     testsignals
     testinputbuffer
-    testlog)
+    testlog
+    testeventdispatcher)
 
 set(FCITX_UTILS_DBUS_TEST
     testdbusmessage
@@ -28,6 +29,7 @@
     testservicewatcher)
 
 set(testdbus_LIBS Pthread::Pthread)
+set(testeventdispatcher_LIBS Pthread::Pthread)
 
 add_executable(DBusWrapper IMPORTED)
 set_target_properties(DBusWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/dbus_wrapper.sh")
@@ -79,5 +81,5 @@
 add_executable(testxkbrules testxkbrules.cpp ../src/im/keyboard/xkbrules.cpp ../src/im/keyboard/xmlparser.cpp)
 target_compile_definitions(testxkbrules PRIVATE "-D_TEST_XKBRULES")
 target_include_directories(testxkbrules PRIVATE ../src)
-target_link_libraries(testxkbrules Fcitx5::Utils Expat::Expat)
+target_link_libraries(testxkbrules Fcitx5::Core Expat::Expat)
 add_test(NAME testxkbrules COMMAND testxkbrules)

=== src/frontend/CMakeLists.txt ===
add_subdirectory(xim)
add_subdirectory(dbusfrontend)
add_subdirectory(waylandim)
add_subdirectory(ibusfrontend)

=== src/lib/CMakeLists.txt ===
add_subdirectory(fcitx-utils)
add_subdirectory(fcitx-config)
add_subdirectory(fcitx)
add_subdirectory(fcitx-wayland)

=== src/modules/CMakeLists.txt ===
add_subdirectory(xcb)
add_subdirectory(dbus)
add_subdirectory(wayland)
add_subdirectory(spell)
add_subdirectory(notifications)
add_subdirectory(notificationitem)
add_subdirectory(quickphrase)
add_subdirectory(unicode)
add_subdirectory(clipboard)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ModuleConfigVersion.cmake" VERSION @FCITX_VERSION@ COMPATIBILITY AnyNewerVersion)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Fcitx5ModuleConfig.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ModuleConfig.cmake" @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ModuleConfigVersion.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ModuleConfig.cmake"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Module
        COMPONENT Devel )

configure_file(Fcitx5Module.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Module.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Module.pc
  DESTINATION "${CMAKE_INSTALL_LIBDATADIR}/pkgconfig")

=== src/ui/CMakeLists.txt ===
add_subdirectory(classic)
add_subdirectory(kimpanel)
add_subdirectory(simpleui)

=== test/addon/CMakeLists.txt ===
add_library(dummyaddon MODULE dummyaddon.cpp)
target_link_libraries(dummyaddon Fcitx5::Core)

=== src/frontend/ibusfrontend/CMakeLists.txt ===
add_library(ibusfrontend MODULE ibusfrontend.cpp)
target_link_libraries(ibusfrontend Fcitx5::Core Fcitx5::Module::DBus)
set_target_properties(ibusfrontend PROPERTIES PREFIX "")
install(TARGETS ibusfrontend DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(ibusfrontend.conf.in ibusfrontend.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ibusfrontend.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")

=== src/frontend/waylandim/CMakeLists.txt ===
set(WAYLAND_IM_PROTOCOL_SRCS)

ecm_add_wayland_client_protocol(WAYLAND_IM_PROTOCOL_SRCS
    PROTOCOL ${WAYLAND_PROTOCOLS_PKGDATADIR}/unstable/text-input/text-input-unstable-v1.xml
    BASENAME text-input-unstable-v1)

add_library(waylandim MODULE waylandim.cpp ${WAYLAND_IM_PROTOCOL_SRCS})
target_include_directories(waylandim PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(waylandim Fcitx5::Core Wayland::Client XKBCommon::XKBCommon Fcitx5::Module::Wayland Fcitx5::Wayland::Core Fcitx5::Wayland::InputMethod)
set_target_properties(waylandim PROPERTIES PREFIX "")
install(TARGETS waylandim DESTINATION "${FCITX_INSTALL_ADDONDIR}")
fcitx5_translate_desktop_file(waylandim.conf.in waylandim.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/waylandim.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")

=== src/im/keyboard/CMakeLists.txt ===
add_library(keyboard STATIC keyboard.cpp isocodes.cpp xkbrules.cpp xmlparser.cpp)
target_link_libraries(keyboard Fcitx5::Core Expat::Expat LibIntl::LibIntl XKBCommon::XKBCommon Fcitx5::Module::XCB Fcitx5::Module::Spell Fcitx5::Module::Notifications PkgConfig::JsonC ${FMT_TARGET})
target_include_directories(keyboard PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
fcitx5_translate_desktop_file(keyboard.conf.in keyboard.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/keyboard.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")
fcitx5_export_module(Keyboard TARGET keyboard BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS keyboard_public.h)

=== src/lib/fcitx-config/CMakeLists.txt ===
set(FCITX_CONFIG_SOURCES
    rawconfig.cpp
    option.cpp
    configuration.cpp
    marshallfunction.cpp
    iniparser.cpp
    dbushelper.cpp
    )

set(FCITX_CONFIG_HEADERS
    rawconfig.h
    option.h
    configuration.h
    marshallfunction.h
    iniparser.h
    enum.h
    optiontypename.h
    dbushelper.h
    ${CMAKE_CURRENT_BINARY_DIR}/fcitxconfig_export.h
    )


add_library(Fcitx5Config SHARED ${FCITX_CONFIG_SOURCES})
set_target_properties(Fcitx5Config
  PROPERTIES VERSION 5.0
  SOVERSION 5
  EXPORT_NAME Config
  )
target_include_directories(Fcitx5Config PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/Fcitx5/Config>)
target_link_libraries(Fcitx5Config PUBLIC Fcitx5::Utils)

configure_file(Fcitx5Config.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Config.pc @ONLY)

install(TARGETS Fcitx5Config EXPORT Fcitx5ConfigTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5Config.pc
  DESTINATION "${CMAKE_INSTALL_LIBDATADIR}/pkgconfig")
install(FILES ${FCITX_CONFIG_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/Config/fcitx-config")

add_library(Fcitx5::Config ALIAS Fcitx5Config)

generate_export_header(Fcitx5Config BASE_NAME FcitxConfig)
ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ConfigConfigVersion.cmake"
                  SOVERSION 5)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Fcitx5ConfigConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ConfigConfig.cmake"
                              INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Config
)

install(EXPORT Fcitx5ConfigTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Config FILE Fcitx5ConfigTargets.cmake NAMESPACE Fcitx5::)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ConfigConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5ConfigConfigVersion.cmake"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5Config
        COMPONENT Devel )

=== src/lib/fcitx-utils/CMakeLists.txt ===
--- 
+++ 
@@ -2,14 +2,14 @@
   set(FCITX_UTILS_SOURCES
       dbus/libdbus/bus.cpp
       dbus/libdbus/message.cpp
-      dbus/libdbus/objectvtable.cpp
+      dbus/libdbus/objectvtable_libdbus.cpp
       dbus/libdbus/servicenamecache.cpp)
 else()
   set(FCITX_UTILS_SOURCES
       dbus/sdbus/bus.cpp
       dbus/sdbus/message.cpp
       dbus/sdbus/objectvtablewrapper.c
-      dbus/sdbus/objectvtable.cpp)
+      dbus/sdbus/objectvtable_sdbus.cpp)
 endif()
 
 if (NOT TARGET Systemd::Systemd)
@@ -27,12 +27,14 @@
     dbus/servicewatcher.cpp
     dbus/matchrule.cpp
     dbus/variant.cpp
+    dbus/objectvtable.cpp
     stringutils.cpp
     key.cpp
     cutf8.cpp
     color.cpp
     i18nstring.cpp
     event_common.cpp
+    eventdispatcher.cpp
     library.cpp
     fs.cpp
     standardpath.cpp
@@ -54,6 +56,7 @@
     color.h
     i18nstring.h
     event.h
+    eventdispatcher.h
     library.h
     cutf8.h
     fs.h

=== debian/changelog ===
fcitx5 (0.0~git20200128.9e3bc8d+ds1-3) unstable; urgency=medium

  * debian/README.Debian: Add a README introducing how to use
    fcitx5 properly.
  * debian/control: Suggest installing im-config (>= 0.44).

 -- Boyuan Yang <byang@debian.org>  Wed, 12 Feb 2020 22:37:27 -0500

fcitx5 (0.0~git20200128.9e3bc8d+ds1-2) unstable; urgency=medium

  * debian/control:
    - Do not let the fcitx5-module-quickphrase package recommend
      fcitx5-module-quickphrase-editor package. It is currently
      provided by fcitx4.
  * debian/upstream/metadata:
    + Add information: Repository, Repository-Browse.
  * debian/copyright: Refresh information.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Feb 2020 11:35:16 -0500

fcitx5 (0.0~git20200128.9e3bc8d+ds1-1) unstable; urgency=medium

  * debian/control:
    + Mark package fcitx5 to be suggesting the Qt/GTK frontend
      packages.
    + Convert package fcitx5-modules to be in metapackages section.
    + Bump Standards-Version to 4.5.0.
  * ds: No longer ships libime-related dictionaries in fcitx5-data
        package.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Feb 2020 14:19:46 -0500

fcitx5 (0.0~git20200117.a2871df+ds2-1) unstable; urgency=medium

  * data/: Also include py_*.mb, used by fcitx5 pinyinhelper module.

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Jan 2020 18:18:58 -0500

fcitx5 (0.0~git20200117.a2871df+ds1-1) unstable; urgency=medium

  * New upstream snapshot (git 20200117).

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Jan 2020 14:19:36 -0500

fcitx5 (0.0~git20191231.c0a272a+ds1-2) unstable; urgency=medium

  * debian/control: Build-depend on libenchant 2.x instead of
    old 1.x.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Jan 2020 11:39:57 -0500

fcitx5 (0.0~git20191231.c0a272a+ds1-1) unstable; urgency=medium

  * New upstream snapshot (git 20191231).

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2020 13:16:10 -0800

fcitx5 (0.0~git20191114.c2b3517+ds1-1) unstable; urgency=medium

  * New upstream snapshot (git 20191114).
  * debian/watch: Monitor upstream git HEAD.

 -- Boyuan Yang <byang@debian.org>  Sat, 30 Nov 2019 12:31:02 -0500

fcitx5 (0~20191021+ds2-2) unstable; urgency=medium

  * libfcitx5utils-dev.install: Also install the *.cmake.in files.
    This might be useful to some users.

 -- Boyuan Yang <byang@debian.org>  Thu, 28 Nov 2019 13:30:27 -0500

fcitx5 (0~20191021+ds2-1) unstable; urgency=medium

  * data: Placd data files into /data/ subdirectory.
  * debian/patches: Refresh patch accordingly.
  * debian/fcitx5-data.install: Refresh data install instruction.

 -- Boyuan Yang <byang@debian.org>  Tue, 26 Nov 2019 10:27:25 -0500

fcitx5 (0~20191021+ds1-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/control:
    + Bump Standards-Version to 4.4.1.
    + Set homepage back to GitHub project.
  * debian/watch: Monitor releases on GitHub.

 -- Boyuan Yang <byang@debian.org>  Fri, 25 Oct 2019 00:33:48 -0400

fcitx5 (0~20190716+ds1-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/control:
    + Bump Standards-Version to 4.4.0.
    + Mark multiple packages as M-A: same.

 -- Boyuan Yang <byang@debian.org>  Wed, 11 Sep 2019 11:30:13 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.6.0),
- dbus,
+ dbus <!nocheck>,
  debhelper-compat (= 12),
  extra-cmake-modules,
  gettext,
@@ -14,7 +14,7 @@
  libcairo2-dev,
  libdbus-1-dev,
  libegl1-mesa-dev,
- libenchant-dev,
+ libenchant-2-dev,
  libevent-dev,
  libexpat1-dev,
  libfmt-dev,
@@ -39,9 +39,9 @@
  pkg-config,
  uuid-dev,
  wayland-protocols,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
-Homepage: https://gitlab.com/fcitx/fcitx5
+Homepage: https://github.com/fcitx/fcitx5
 Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5
 
@@ -55,6 +55,12 @@
  libfcitx5utils1 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
+Suggests:
+ fcitx5-frontend-qt5,
+ fcitx5-frontend-gtk3,
+ fcitx5-frontend-gtk2,
+ fcitx5-chinese-addons,
+ im-config (>= 0.44),
 Description: Next generation of Fcitx Input Method Framework
  Fcitx5 is the next generation of fcitx input method framework. It
  provides plasant and modern input experience with intuitive graphical
@@ -90,6 +96,7 @@
 
 Package: fcitx5-module-dbus
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -109,6 +116,7 @@
 
 Package: fcitx5-module-ibus
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -128,6 +136,7 @@
 
 Package: fcitx5-module-kimpanel
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -147,6 +156,7 @@
 
 Package: fcitx5-module-wayland
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -166,6 +176,7 @@
 
 Package: fcitx5-module-xorg
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -189,8 +200,6 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Recommends:
- fcitx5-module-quickphrase-editor,
 Description: Fcitx Input Method Framework v5 (quickphrase module)
  Fcitx5 is the next generation of fcitx input method framework. It
  provides plasant and modern input experience with intuitive graphical
@@ -206,7 +215,9 @@
  This package provides quickphrase module for fcitx5.
 
 Package: fcitx5-modules
-Architecture: linux-any
+Section: metapackages
+Architecture: linux-any
+Multi-Arch: same
 Depends:
  fcitx5-data (= ${source:Version}),
  ${misc:Depends},
@@ -235,6 +246,7 @@
 
 Package: fcitx5-modules-dev
 Architecture: linux-any
+Multi-Arch: same
 Section: libdevel
 Depends:
  fcitx5-module-dbus (= ${binary:Version}),
@@ -261,6 +273,7 @@
 
 Package: libfcitx5config-dev
 Architecture: linux-any
+Multi-Arch: same
 Section: libdevel
 Depends:
  libfcitx5config5 (= ${binary:Version}),
@@ -302,6 +315,7 @@
 
 Package: libfcitx5core-dev
 Architecture: linux-any
+Multi-Arch: same
 Section: libdevel
 Depends:
  libfcitx5core5 (= ${binary:Version}),
@@ -313,10 +327,3 @@
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.
  .
- Some of its new features include support of both Wayland and Xorg
- and the ability to mimic IBus Input Method Framework in order to
- provide better compatibility across different Linux distributions
- and desktop environments.
- .
- This package provides development files for fcitx5 core libraries.
-

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, dversionmangle=s/\+ds\d*//" \
 https://github.com/fcitx/fcitx5.git \
  HEAD debian uupdate
